# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetFederatedDatabaseInstancesResult',
    'AwaitableGetFederatedDatabaseInstancesResult',
    'get_federated_database_instances',
    'get_federated_database_instances_output',
]

@pulumi.output_type
class GetFederatedDatabaseInstancesResult:
    """
    A collection of values returned by getFederatedDatabaseInstances.
    """
    def __init__(__self__, id=None, project_id=None, results=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if project_id and not isinstance(project_id, str):
            raise TypeError("Expected argument 'project_id' to be a str")
        pulumi.set(__self__, "project_id", project_id)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> str:
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetFederatedDatabaseInstancesResultResult']:
        """
        Includes Federated Database instance for each item detailed in the results array section.
        """
        return pulumi.get(self, "results")


class AwaitableGetFederatedDatabaseInstancesResult(GetFederatedDatabaseInstancesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFederatedDatabaseInstancesResult(
            id=self.id,
            project_id=self.project_id,
            results=self.results)


def get_federated_database_instances(project_id: Optional[str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFederatedDatabaseInstancesResult:
    """
    `mongodbatlas_federated_database_instancess` provides a Federated Database Instance data source.

    > **NOTE:** Groups and projects are synonymous terms. You may find group_id in the official documentation.

    > **IMPORTANT:** All arguments including the password will be stored in the raw state as plain text. Read more about sensitive data in state.

    ## Example Usage


    :param str project_id: The unique ID for the project to create a Federated Database Instance.
    """
    __args__ = dict()
    __args__['projectId'] = project_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('mongodbatlas:index/getFederatedDatabaseInstances:getFederatedDatabaseInstances', __args__, opts=opts, typ=GetFederatedDatabaseInstancesResult).value

    return AwaitableGetFederatedDatabaseInstancesResult(
        id=pulumi.get(__ret__, 'id'),
        project_id=pulumi.get(__ret__, 'project_id'),
        results=pulumi.get(__ret__, 'results'))


@_utilities.lift_output_func(get_federated_database_instances)
def get_federated_database_instances_output(project_id: Optional[pulumi.Input[str]] = None,
                                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetFederatedDatabaseInstancesResult]:
    """
    `mongodbatlas_federated_database_instancess` provides a Federated Database Instance data source.

    > **NOTE:** Groups and projects are synonymous terms. You may find group_id in the official documentation.

    > **IMPORTANT:** All arguments including the password will be stored in the raw state as plain text. Read more about sensitive data in state.

    ## Example Usage


    :param str project_id: The unique ID for the project to create a Federated Database Instance.
    """
    ...
